/**
 * Copyright bradsedito ( http://wonderfl.net/user/bradsedito )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/Aixe
 */






package 
{
    import flash.display.*;
    import flash.geom.*;
    import flash.events.*;
    import flash.utils.*;
    import flash.geom.*;
    import net.hires.debug.Stats;
    
    [SWF(backgroundColor="0")];
    
    public class Liquid extends Sprite 
    {
        private const NUM_PARTICLE:uint = 100;
        private const DEPTH:uint = 5000;
        private var bmpData:BitmapData = new BitmapData( 465, 465, false, 0x000000 );
        private var forceMap:BitmapData = new BitmapData( 57, 57, false, 0x000000 );
        private var randomSeed:uint = Math.floor( Math.random() * 0xFFFF );
        private var particleList:Vector.<Particle> = new Vector.<Particle>(NUM_PARTICLE, true);
        private var rect:Rectangle = new Rectangle( 0, 0, 465, 465 );
        private var seed:Number = Math.floor( Math.random() * 0xFFFF );
        private var offset:Array = [new Point(), new Point()];
        private var colorTransform:ColorTransform = new ColorTransform( 1.00,1.00,1.00,0.00 );
        private var timer:Timer;
        private var lastMouseX:Number = 0;
        private var lastMouseY:Number = 0;

        public function Liquid() 
        {
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.quality = StageQuality.HIGH;
            stage.frameRate = 60;
            
            addChild(new Bitmap( bmpData )) as Bitmap;
            
            forceMap.perlinNoise( 14, 14, 3, randomSeed, false, true, 1 | 2 | 0 | 0 );
            
            for (var i:uint = 0; i < NUM_PARTICLE; i++) {
                var px:Number = Math.random() * 465;
                var py:Number = Math.random() * 465;
                var pz:Number = Math.random() * DEPTH;
                particleList[i] = new Particle(px, py, pz);
            }
            
            addEventListener( Event.ENTER_FRAME, loop );
            
            timer = new Timer(1000, 0);
            timer.addEventListener(TimerEvent.TIMER, resetFunc);
            timer.start();
            addChild(new Stats);
        }
        
        private function loop( e:Event ):void {
            bmpData.lock();
            bmpData.colorTransform( rect, colorTransform );
            
            var len:uint = particleList.length;
            var col:Number;
            
            var sx:Number = 5000 * (mouseX - lastMouseX);
            var sy:Number = 5000 * (mouseY - lastMouseY);
            var sz:Number = (sx+sy)/2;
            var dx:Number, dy:Number;
            var dist:Number;            
            var mx:int = mouseX;
            var my:int = mouseY;
            
            for (var i:uint = 0; i < len; i++) 
            {
                
                var dots:Particle = particleList[i];

                dx = dots.px - mx;
                dy = dots.py - my;
                dist = dx * dx + dy * dy + 50;
                col = forceMap.getPixel( dots.px >> 3,  dots.py >> 3);
                dots.ax += ( (col >> 16 & 0xff) - 128 ) * .0005;
                dots.ay += ( (col >> 8  & 0xff) - 128 ) * .0005;
                dots.az += ( (col >> 8  & 0xff) - 128 ) * .0005;
                dots.vx += dots.ax;
                dots.vy += dots.ay;
                dots.vz += dots.az;
                dots.px += dots.vx + sx / dist;
                dots.py += dots.vy + sy / dist;
                dots.pz += dots.vz * DEPTH;

                var _posX:Number = dots.px;
                var _posY:Number = dots.py;
                var _posZ:Number = dots.pz;
                    
                dots.ax *= .96;
                dots.ay *= .96;
                dots.az *= .96;
                dots.vx *= .92;
                dots.vy *= .92;
                dots.vz *= 1.92;
                
                ( _posX > 465 ) ? dots.px = 0 :
                ( _posX < 0 ) ? dots.px = 465 : 0;
                ( _posY > 465 ) ? dots.py = 0 :
                ( _posY < 0 ) ? dots.py = 465 : 0;
                ( _posZ > 0 ) ? dots.pz = 0 :
                ( _posZ < 0 ) ? dots.pz = DEPTH : 0;
                                
                bmpData.setPixel( dots.px, dots.py, 0xffffff );
            }
            bmpData.unlock();
            
            lastMouseX = mouseX;
            lastMouseY = mouseY;
        }
        
        private function resetFunc(e:Event):void {
            forceMap.perlinNoise( 14, 14, 3, seed, false, true, 1|2|0|0, false, offset );
            offset[0].x += 1.5;
            offset[0].z += 1.5;
            offset[1].y += 1.0;    
        }
    }
}

class Particle {
    public var vx:Number = 0;
    public var vy:Number = 0;
     public var vz:Number = 0;
    public var ax:Number = 0;
    public var ay:Number = 0;
     public var az:Number = 0;
    public var px:Number;
    public var py:Number;
     public var pz:Number;

    function Particle( px:Number, py:Number, pz:Number ) {
        this.px = px;
        this.py = py;
        this.pz = pz;
    }
}